<template>
  <v-container>
    <v-layout
      text-center
      wrap
    >
      <v-flex mb-4>
        <h1 class="display-2 font-weight-bold mb-3">
          Добро пожаловать в Word Game
        </h1>
      </v-flex>

      <v-flex
        xs12
        mb-5
        v-if="!gameOver"
      >
        <v-layout justify-center>
          <v-card
                  class="mx-auto"
          >
            <img
                    class="v-responsive v-image ml-auto mr-auto"
                    :src="getImage"
            />
            <v-card-actions class="flex-wrap">
              <div class="box mr-2 mt-2"
                      v-for="(letter, i) in randomLetters"
              >{{ letters[i] }}</div>
            </v-card-actions>
            <v-card-actions class="flex-wrap">
              <v-btn v-for="(letter, i) in randomLetters" class="mt-2" @click="onClick(letter)">{{ letter }}</v-btn>
            </v-card-actions>
            <v-card-actions>
              <v-btn @click="reset()">Сбросить</v-btn>
            </v-card-actions>
            <hr class="mt-4" v-if="won">
            <v-card-actions class="mt-4" v-if="won">
              <v-flex>
                <p class="subheading font-weight-regular">Вы выиграли! Повторить?</p>
                <v-btn outlined @click="restart">Конечно</v-btn>
                <v-btn outlined @click="restart(), gameOver=true">Я уже устал</v-btn>
              </v-flex>
            </v-card-actions>
          </v-card>
        </v-layout>
      </v-flex>
      <v-flex v-if="gameOver">
        <v-layout>
          <v-card class="mx-auto">
            <v-card-actions class="mt-4">
              <template>
                <v-data-table
                        :headers="headers"
                        :items="gameResults"
                        :hide-default-footer="true"
                ></v-data-table>
              </template>
            </v-card-actions>
          </v-card>
        </v-layout>
      </v-flex>

    </v-layout>
  </v-container>
</template>

<script>
  import { fetchWord } from "../store";

  export default {
  data () {
    return {
      wordResult: null,
      letters: [],
      counter: 0,
      gameOver: false,
      startedTime: null,
      gameResults: [],
      headers: [
        {text: 'Номер', value: 'count'},
        {text: 'Слово', value: 'word'},
        {text: 'Время выполнения', value: 'duration'}
      ]
    }
  },
    created () {
      this.fetchRandomWord()
    },
    computed: {
      randomLetters () {
        if (this.wordResult !== null){
          return this.wordResult.name.split('').sort( function() { return 0.5 - Math.random() } );
        }
        return []
      },
      won () {
        if (this.wordResult !== null) {
          return this.letters.join('') === this.wordResult.name
        }
        return false
      },

      getImage() {
        if (this.wordResult !== null) {
          return this.wordResult.img_src
        }
        return ''
      },

    },
  methods: {
    async fetchRandomWord() {
      this.wordResult = await fetchWord()
      this.startedTime = new Date()
    },
    onClick(letter) {
      this.letters.push(letter)
    },
    reset() {
      this.letters = []
    },
    restart() {
      this.addResult()
      this.reset()
      this.fetchRandomWord()
    },
    addResult() {
      this.counter++
      this.gameResults.push({
        count: this.counter,
        word: this.wordResult.name,
        duration: this.msToTime(new Date() - this.startedTime)
      })
    },
    msToTime(s) {
      let ms = s % 1000;
      s = (s - ms) / 1000;
      let secs = s % 60;
      s = (s - secs) / 60;
      let mins = s % 60;
      let hrs = (s - mins) / 60;

      return hrs + ':' + mins + ':' + secs + '.' + ms;
    }
  }
};
</script>

<style>
  .box {
    text-align: center;
    background: #FFFFFF;
    width: 64px;
    border-radius: 5px;
    height: 36px;
    display: flex;
    align-items: center;
    justify-content: center;
    transition: background 0.3s cubic-bezier(0.25, 0.8, 0.5, 1);
    box-shadow: 0px 3px 1px -2px rgba(0, 0, 0, 0.2), 0px 2px 2px 0px rgba(0, 0, 0, 0.14), 0px 1px 5px 0px rgba(0, 0, 0, 0.12);
  }
</style>


